.span

WinMain proc uses edi esi hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:dword

	local	hwnd:HWND	
	local	msg:MSG
	local	hMenu:HANDLE
	
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	; Register the class
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	m2m		wc.hInstance, hInst
	mov		wc.lpszClassName, offset szClassName
	mov		wc.lpfnWndProc, offset WndProc
	mov		wc.style, CS_DBLCLKS
	mov		wc.cbSize, sizeof WNDCLASSEX
	mov		wc.hIcon, func(LoadIcon, hInst, 100)
	mov		wc.hIconSm, eax
	mov		wc.hCursor, func(LoadCursor, NULL, IDC_ARROW)
	mov		wc.lpszMenuName, NULL
	mov		wc.cbClsExtra, 0
	mov		wc.cbWndExtra, 0
	mov		wc.hbrBackground, COLOR_BACKGROUND	
	.if		!func(RegisterClassEx, addr wc)
			return 1
	.endif

	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	; Create the window
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	mov		edi, func(GetSystemMetrics, SM_CXSCREEN) 
	shr		edi, 1
	mov		eax, WND_WIDTH
	shr		eax, 1
	sub		edi, eax
	
	mov		esi, func(GetSystemMetrics, SM_CYSCREEN)
	shr		esi, 1
	mov		eax, WND_HEIGHT
	shr		eax, 1
	sub		esi, eax

	invoke	CreateWindowEx,\
			WS_EX_APPWINDOW or WS_EX_WINDOWEDGE, \
			addr szClassName,\
			addr szWndText,\
           	WS_OVERLAPPEDWINDOW,\
           	edi,\
           	esi,\
           	WND_WIDTH,\
           	WND_HEIGHT,\
           	NULL,\
           	func(LoadMenu, hInst, 1000),\
           	hInst,\
           	NULL   	
	mov		hwnd, eax

	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	; Make the window visible
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	invoke	SendMessage, hwnd, WM_SETICON, ICON_BIG or ICON_SMALL, func(LoadIcon, hInst, 1000)
	invoke	ShowWindow, hwnd, CmdShow
	invoke	UpdateWindow, hwnd
	
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	; Messageloop (with IsDialogMessage)
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	.while TRUE
		invoke GetMessage, addr msg, hwnd, 0, 0
		.break .if eax!=TRUE
		.if !func(IsDialogMessage,hwnd,addr msg)
			invoke	TranslateMessage, addr msg
			invoke	DispatchMessage, addr msg
		.endif
	.endw
	
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	; Exit WinMain
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	mov eax, msg.wParam
	ret
	
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	; This is the actual test for MsgCrack.inc macros
	; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=	
	.handle_msg_begin
		.handle_msg WM_CREATE, WmCreate
		.handle_msg WM_DESTROY, WmDestroy
		.handle_msg WM_COMMAND, WmCommand
		.handle_msg WM_SIZE, WmSize
		.handle_msg WM_SIZING, WmSizing
		.handle_msg WM_MOUSEMOVE, WmMouseMove
		.handle_msg WM_MOUSELEAVE, WmMouseLeave
		.handle_msg WM_NCMOUSEMOVE, WmNcMouseMove
		.handle_msg WM_NCMOUSELEAVE, WmNcMouseLeave
		.handle_msg WM_MOVE, WmMove
		.handle_msg WM_MOVING, WmMoving
		.handle_msg WM_LBUTTONDOWN, WmLButtonDown
		.handle_msg WM_MBUTTONDOWN, WmMButtonDown
		.handle_msg WM_RBUTTONDOWN, WmRButtonDown
		.handle_msg WM_XBUTTONDOWN, WmXButtonDown
		.handle_msg WM_LBUTTONUP, WmLButtonUp
		.handle_msg WM_MBUTTONUP, WmMButtonUp
		.handle_msg WM_RBUTTONUP, WmRButtonUp
		.handle_msg WM_XBUTTONUP, WmXButtonUp
		.handle_msg WM_MOUSEWHEEL, WmMouseWheel
		.handle_msg WM_KEYDOWN, WmKey
		.handle_msg WM_KEYUP, WmKey
		.handle_msg WM_CHAR, WmKey
		.handle_msg WM_SYSKEYDOWN, WmSysKey
		.handle_msg WM_SYSKEYUP, WmSysKey
		.handle_msg WM_ACTIVATE, WmActivate
	.handle_msg_end
	
	invoke	DefWindowProc, hWnd, uMsg, wParam, lParam
	ret

WndProc endp

LstWndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM	
	invoke	CallWindowProc, wndlbox, hWnd, uMsg, wParam, lParam

	cmp 	uMsg, WM_NCHITTEST
	jnz		@f
	mov		eax, -1
	@@:
	ret
LstWndProc endp

TrackMouseLeaveTimerProc proc hWnd:HWND, uMsg:UINT, idEvent:UINT, dwTime:dword
	local rect:RECT
	local pt:POINT
	
	invoke	GetClientRect, hWnd, addr rect
	invoke	MapWindowPoints, hWnd, NULL, addr rect, 2
	invoke	GetCursorPos, addr pt

	invoke	WindowFromPoint, pt.x, pt.y
	.if eax!=hWnd
		invoke	GetCapture
		.if eax!=hWnd
			invoke	KillTimer, hWnd, idEvent
			invoke	PostMessage, hWnd, WM_MOUSELEAVE, 0, 0
		.endif
	.else
		invoke	GetCapture
		.if eax!=hWnd
			invoke	PtInRect, addr rect, pt.x, pt.y
			.if !eax
				invoke	KillTimer, hWnd, idEvent
				invoke	PostMessage, hWnd, WM_MOUSELEAVE, 0, 0
			.endif
		.endif
	.endif
	
	ret
TrackMouseLeaveTimerProc endp

TrackNcMouseLeaveTimerProc proc hWnd:HWND, uMsg:UINT, idEvent:UINT, dwTime:dword
	local rect:RECT
	local pt:POINT
	
	invoke	GetWindowRect, hWnd, addr rect
	invoke	MapWindowPoints, hWnd, NULL, addr rect, 2
	invoke	GetCursorPos, addr pt

	invoke	WindowFromPoint, pt.x, pt.y
	.if eax!=hWnd
		invoke	GetCapture
		.if eax!=hWnd
			invoke	KillTimer, hWnd, idEvent
			invoke	PostMessage, hWnd, WM_NCMOUSELEAVE, 0, 0
		.endif
	.else
		invoke	GetCapture
		.if eax!=hWnd
			invoke	PtInRect, addr rect, pt.x, pt.y
			.if !eax
				invoke	KillTimer, hWnd, idEvent
				invoke	PostMessage, hWnd, WM_NCMOUSELEAVE, 0, 0
			.endif
		.endif
	.endif
	
	ret
TrackNcMouseLeaveTimerProc endp